<?php // $Id: pay_method.inc,v 1.5 2009/08/21 02:49:22 vauxia Exp $

/**
 * @file
 * The base class for payment activities.  All payment method classes should
 * extend this class.
 */

class pay_method extends pay {

  var $pmid;
  var $title;
  var $description;
  var $min_amount;
  var $max_amount;
  var $total;
  var $status;
  var $billto = array();
  var $table = 'pay_method';
  var $key = 'pmid';

  function set_activity($val = NULL) {
    $this->activity = check_plain($val);
  }

  function settings_form(&$form_state) {
    $form = parent::settings_form($form_state);
    $form['title'] = array(
      '#type' => 'textfield',
      '#title' => t('Name'),
      '#description' => t('This is what users see when they submit payments.  It is a good idea to keep it generic, such as "Credit card".'),
      '#default_value' => $this->title,
    );
    $form['description'] = array(
      '#type' => 'textfield',
      '#title' => t('Description'),
      '#description' => t('This is how the payment method will be listed in admin interfaces.  Use something that will set this apart from other payment methods.'),
      '#default_value' => $this->description,
    );
    $form['status'] = array(
      '#type' => 'checkbox',
      '#title' => t('Enabled'),
      '#default_value' => isset($this->status) ? $this->status : 1,
    );
    $form['min_amount'] = array(
      '#type' => 'textfield',
      '#size' => 10,
      '#title' => t('Minimum amount'),
      '#default_value' => $this->min_amount,
    );
    $form['max_amount'] = array(
      '#type' => 'textfield',
      '#size' => 10,
      '#title' => t('Maximum amount'),
      '#default_value' => $this->max_amount,
    );

    return $form;
  }

  // This is called from the form_validate function in a pay_form class.
  function pay_method_validate($form, &$form_state, $key, $element) {

    // Confirm that the amount falls within our min/max settings.
    if (($this->total < $this->min_amount) || ($this->total > $this->max_amount) ) {
      $total_error = t('Please enter an amount between %min and %max', array('%min' =>$this->min_amount, '%max' => $this->max_amount));
      form_set_error('total', $error);
    }
  }
}
