<?php // $Id: pay_transaction.inc,v 1.7 2009/08/21 02:49:22 vauxia Exp $

class pay_transaction extends pay {
  var $pxid;
  var $pfid;
  var $pay_status;
  var $uid;
  var $created;
  var $completed;
  var $total;
  var $total_paid;
  var $currency;
  var $notes;
  var $notes_format = FILTER_FORMAT_DEFAULT;
  var $mail;

  var $key = 'pxid';
  var $table = 'pay_transaction';

  function add_activity($pay_method, $activity) {
    $pay_activity = New pay_activity($values);
    $pay_activity->pxid = $this->pxid;
    $pay_activity->pay_method = $pay_method;
    $pay_activity->set_total($pay_method->total);
    $pay_activity->set_activity($activity);
    $pay_activity->save();

    return $pay_activity;
  }

  function update_status($timestamp = NULL, $force = FALSE) {
    $this->total_paid = db_result(db_query("SELECT SUM(transaction_total) 
      FROM pay_activity WHERE pxid = %d", $this->pxid));

    if ($force || ($this->total == $this->total_paid)) {
      if (!$timestamp) $timestamp = time();
      $this->set_completed($timestamp);
    }

    $this->save();
  }
}

class pay_activity extends pay {
  var $paid;
  var $pxid;
  var $pmid;
  var $uid;
  var $result = 1;
  var $activity;
  var $payment_type;
  var $total;
  var $transaction_total;
  var $timestamp;
  var $hostname;
  var $data;

  var $table = 'pay_activity';
  var $key = 'paid';

  function save($values = NULL) {
    // Don't apply the amount to the transaction if it failed.
    if (!$this->result) $this->transaction_total = 0;

    // Save to the pay_activity table.
    parent::save($values);
  }

  function do_activity() {
    $this->pmid = $this->pay_method->pmid;
    $this->payment_type = $this->pay_method->payment_type;
    if (method_exists($this->pay_method, 'execute')) {
      $this->result = $this->pay_method->execute($this);
      $this->save();
    }
  }
}
