<?php // $Id: pay.theme.inc,v 1.3 2009/08/21 02:49:22 vauxia Exp $

/**
 * Implementation of hook_theme().
  */
function pay_theme_theme() {
  $path = drupal_get_path('module', 'pay') .'/theme';

  return array(
    'pay' => array(
      'arguments' => array( 'element' => NULL ),
      'file' => 'pay.theme.inc',
      'path' => $path,
    ),
    'pay_cc_form' => array(
      'arguments' => array('element' => array()),
      'template' => 'pay_cc_form',
      'pattern' => 'pay_cc_form__',
      'file' => 'pay.theme.inc',
      'path' => $path,
    ),
  );
}

/**
 * A theme function for the pay element.
 */
function theme_pay($element) {
  return $element['#children'];
}
  
/**
 * A preprocess function for theme('pay_cc_form').
 *
 * The $variables array initially contains the following arguments:
 *
 */
function template_preprocess_pay_cc_form(&$variables) {
  static $first_time = TRUE;

  $variables['pay'] = array();
 
  if ($variables['element']['cc_type']) {
    $path = drupal_get_path('module', 'pay') . '/theme/images/';
    foreach ($variables['element']['cc_type']['#options'] as $card => $label) {
      $variables['element']['cc_type'][$card]['#title'] = '<img src="/'. $path . $card .'.png">';
    }
  }

  foreach (element_children($variables['element']) as $item) {
    $variables['pay'][$item] = drupal_render($variables['element'][$item]);
  }

  if ($first_time) {
    $variables['setup'] = $first_time;
    $first_time = FALSE;  }
  else {
    $variables['setup'] = FALSE;
  }

  $variables['pay_form'] = join('', $variables['pay']);
}
